/*
 * THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT. 
 */
#include <config.h>
#include <stddef.h>
#include <stdlib.h>
#include <stdint.h>
#include <limits.h>

#include <vapi/vsc.h>
#include <vapi/vsm.h>
#include <vcli.h>

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

typedef struct vcli_conn {
    int             fd;
    char           *secret;
    int             resp;
    char           *base;
    size_t          bufmax;
    size_t          bufsize;
} vcli_conn_t;

int             vcli_write(vcli_conn_t * conn);
int             vcli_read_response(vcli_conn_t * conn);
int             vcli_vasprintf(vcli_conn_t * conn, const char *fmt,
                               va_list ap);
int             vcli_asprintf(vcli_conn_t * conn, const char *fmt, ...);
void            vcli_disconnect(vcli_conn_t * conn);
int             vcli_connect(struct VSM_data *vd, vcli_conn_t * conn);

struct VSM_data *varnish_get_vsm_data(void);

int             varnish_auth_response(const char *file,
                                      const char *challenge,
                                      char response[CLI_AUTH_RESPONSE_LEN +
                                                    1]);

int             varnish_ban(netsnmp_agent_request_info *reqinfo,
                            netsnmp_request_info *requests,
                            struct VSM_data *vd);

int             varnish_mib_timeout_parser(const char *token, char *line,
                                           unsigned *retval);

void            varnish_ban_table_timeout_parser(const char *token,
                                                 char *line);
void            varnish_vcli_timeout_parser(const char *token, char *line);

void            varnish_backend_table_timeout_parser(const char *token,
                                                     char *line);

/*
 * column number definitions for table backendTable 
 */
#define COLUMN_VBEINDEX		1
#define COLUMN_VBEIDENT		2
#define COLUMN_VBEIPV4		3
#define COLUMN_VBEIPV6		4
#define COLUMN_VBEPORT		5
#define COLUMN_VBEHAPPYPROBES		6
#define COLUMN_VBEVCLS		7
#define COLUMN_VBEREQUESTHEADERBYTES		8
#define COLUMN_VBEREQUESTBODYBYTES		9
#define COLUMN_VBERESPONSEHEADERBYTES		10
#define COLUMN_VBERESPONSEBODYBYTES		11
#define COLUMN_VBEPIPEHEADERBYTES		12
#define COLUMN_VBEPIPEIN		13
#define COLUMN_VBEPIPEOUT		14

struct backendTable_entry {
    /*
     * Index values 
     */
    long            vbeIndex;

    /*
     * Column values 
     */
    char           *vbeIdent;
    size_t          vbeIdent_len;
    char            vbeIPv4[4];
    size_t          vbeIPv4_len;
    char            vbeIPv6[16];
    size_t          vbeIPv6_len;
    u_long          vbePort;
    U64             vbeHappyProbes;
    U64             vbeVcls;
    U64             vbeRequestHeaderBytes;
    U64             vbeRequestBodyBytes;
    U64             vbeResponseHeaderBytes;
    U64             vbeResponseBodyBytes;
    U64             vbePipeHeaderBytes;
    U64             vbePipeIn;
    U64             vbePipeOut;
};

extern unsigned backendTable_timeout;
int             backendTable_load(netsnmp_cache * cache, void *vmagic);
void            backendTable_free(netsnmp_cache * cache, void *vmagic);
/*
 * column number definitions for table banTable 
 */
#define COLUMN_BANINDEX		1
#define COLUMN_BANTIME		2
#define COLUMN_BANREFCOUNT		3
#define COLUMN_BANEXPRESSION		4

struct banTable_entry {
    /*
     * Index values 
     */
    long            banIndex;

    /*
     * Column values 
     */
    char           *banTime;
    size_t          banTime_len;
    u_long          banRefCount;
    char           *banExpression;
    size_t          banExpression_len;
};

extern unsigned banTable_timeout;
int             banTable_load(netsnmp_cache * cache, void *vmagic);
void            banTable_free(netsnmp_cache * cache, void *vmagic);
